// Copyright (C) 2006 Pushok Software http://www.pushok.com/soft_svncom.php
//
// LICENSE
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License (GPL)
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// To read the license please visit http://www.gnu.org/copyleft/gpl.html
//
// Subversion is Copyrght of(c) 2000-2004 CollabNet.  All rights reserved.
// Full license available here http://subversion.tigris.org/license-1.html.

#pragma once

#include "resource.h"       // main symbols
#include <atlhost.h>
#include "SVNAuthProvider.h"
#include "stdafx.h"

// CLoginDlg

class CLoginDlg : 
	public CAxDialogImpl<CLoginDlg>
{
public:
	CLoginDlg()
	{
		m_nAsk = SVNAuthProviderAskUserAndPassword;
	}

	~CLoginDlg()
	{
	}

	enum { IDD = IDD_LOGINDLG };

	SVNAuthProviderAsk m_nAsk;
	CString m_sDlgName;
	CString m_sUserText;
	CString m_sUserName;
	CString m_sPsswText;
	CString m_sPassword;
	CString m_sRealm;
	BOOL	m_bMaySave;

BEGIN_MSG_MAP(CLoginDlg)
	MESSAGE_HANDLER(WM_INITDIALOG, OnInitDialog)
	COMMAND_HANDLER(IDOK, BN_CLICKED, OnClickedOK)
	COMMAND_HANDLER(IDCANCEL, BN_CLICKED, OnClickedCancel)
	COMMAND_HANDLER(IDC_BRW, BN_CLICKED, OnClickedBrw)
	CHAIN_MSG_MAP(CAxDialogImpl<CLoginDlg>)
END_MSG_MAP()

// Handler prototypes:
//  LRESULT MessageHandler(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled);
//  LRESULT CommandHandler(WORD wNotifyCode, WORD wID, HWND hWndCtl, BOOL& bHandled);
//  LRESULT NotifyHandler(int idCtrl, LPNMHDR pnmh, BOOL& bHandled);

	LRESULT OnInitDialog(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled)
	{
		CAxDialogImpl<CLoginDlg>::OnInitDialog(uMsg, wParam, lParam, bHandled);
		CenterWindow();

		CheckDlgButton(IDC_CHECK_MAY_SAVE, m_bMaySave?BST_CHECKED:BST_UNCHECKED);

		if (m_sDlgName.GetLength())
			::SetWindowText(m_hWnd, m_sDlgName);

		if (m_sUserText.GetLength())
		{
			::SetWindowText(GetDlgItem(IDC_STATIC_USER), m_sUserText);
			::SetWindowText(GetDlgItem(IDC_STATIC_FILE), m_sUserText);
		}
		if (m_sUserName.GetLength())
			::SetWindowText(GetDlgItem(IDC_EDIT_USER), m_sUserName);

		if (m_sPsswText.GetLength())
			::SetWindowText(GetDlgItem(IDC_STATIC_PASSW), m_sPsswText);
		if (m_sPassword.GetLength())
			::SetWindowText(GetDlgItem(IDC_EDIT_PASSW), m_sPassword);

		if (m_sRealm.GetLength())
			::SetWindowText(GetDlgItem(IDC_REALM), m_sRealm);

		switch	(m_nAsk)		
		{
		case SVNAuthProviderAskUser:
			::ShowWindow(GetDlgItem(IDC_STATIC_PASSW), SW_HIDE);
			::ShowWindow(GetDlgItem(IDC_EDIT_PASSW), SW_HIDE);

			::ShowWindow(GetDlgItem(IDC_STATIC_FILE), SW_HIDE);
			::ShowWindow(GetDlgItem(IDC_EDIT_FILE), SW_HIDE);
			::ShowWindow(GetDlgItem(IDC_BRW), SW_HIDE);
			break;
		case SVNAuthProviderAskPassword:
			::SendMessage(GetDlgItem(IDC_EDIT_USER), EM_SETREADONLY, TRUE, 0L);

			::ShowWindow(GetDlgItem(IDC_STATIC_FILE), SW_HIDE);
			::ShowWindow(GetDlgItem(IDC_EDIT_FILE), SW_HIDE);
			::ShowWindow(GetDlgItem(IDC_BRW), SW_HIDE);
			break;
		case SVNAuthProviderAskUserAndPassword:
			::ShowWindow(GetDlgItem(IDC_STATIC_FILE), SW_HIDE);
			::ShowWindow(GetDlgItem(IDC_EDIT_FILE), SW_HIDE);
			::ShowWindow(GetDlgItem(IDC_BRW), SW_HIDE);
			break;
		case SVNAuthProviderAskSslClientCert:
			::ShowWindow(GetDlgItem(IDC_STATIC_USER), SW_HIDE);
			::ShowWindow(GetDlgItem(IDC_EDIT_USER), SW_HIDE);

			::ShowWindow(GetDlgItem(IDC_STATIC_PASSW), SW_HIDE);
			::ShowWindow(GetDlgItem(IDC_EDIT_PASSW), SW_HIDE);
			break;
		case SVNAuthProviderAskSslClientCertPw:
			::ShowWindow(GetDlgItem(IDC_STATIC_USER), SW_HIDE);
			::ShowWindow(GetDlgItem(IDC_EDIT_USER), SW_HIDE);

			::ShowWindow(GetDlgItem(IDC_STATIC_FILE), SW_HIDE);
			::ShowWindow(GetDlgItem(IDC_EDIT_FILE), SW_HIDE);
			::ShowWindow(GetDlgItem(IDC_BRW), SW_HIDE);
			break;
		}

		return 1;  // Let the system set the focus
	}

	LRESULT OnClickedOK(WORD wNotifyCode, WORD wID, HWND hWndCtl, BOOL& bHandled)
	{
		m_bMaySave = IsDlgButtonChecked(IDC_CHECK_MAY_SAVE);

		switch	(m_nAsk)		
		{
		case SVNAuthProviderAskUser:
			GetDlgItemText(IDC_EDIT_USER,m_sUserName);
			break;
		case SVNAuthProviderAskPassword:
		case SVNAuthProviderAskSslClientCertPw:
			GetDlgItemText(IDC_EDIT_PASSW,m_sPassword);
			break;
		case SVNAuthProviderAskUserAndPassword:
			GetDlgItemText(IDC_EDIT_USER,m_sUserName);
			GetDlgItemText(IDC_EDIT_PASSW,m_sPassword);
			break;
		case SVNAuthProviderAskSslClientCert:
			GetDlgItemText(IDC_EDIT_FILE,m_sUserName);
			break;
		}
		EndDialog(wID);
		return 0;
	}

	LRESULT OnClickedCancel(WORD wNotifyCode, WORD wID, HWND hWndCtl, BOOL& bHandled)
	{
		EndDialog(wID);
		return 0;
	}

	LRESULT OnClickedBrw(WORD wNotifyCode, WORD wID, HWND hWndCtl, BOOL& bHandled)
	{
		OPENFILENAMEA ofn;
		TCHAR m_szFileName[260];		// contains full path name after return
		TCHAR m_szFileTitle[1];		// contains full path name after return

		memset(&ofn, 0, sizeof(ofn));

		ofn.lStructSize = sizeof(ofn);
		ofn.hwndOwner = ::GetActiveWindow();
		ofn.lpstrFilter = "All\0*.*\0P12 formatted certificate\0*.p12\0\0";
		ofn.nFilterIndex = 1;
		ofn.lpstrDefExt = "*.p12";
		ofn.lpstrFile = m_szFileName;
		ofn.lpstrFile[0] = '\0';
		ofn.nMaxFile = 259;
		ofn.lpstrFileTitle = m_szFileTitle;
		ofn.lpstrFileTitle[0] = '\0';
		ofn.nMaxFileTitle = 0;
		ofn.lpstrInitialDir = NULL;
		ofn.lpstrTitle = "Please select Sertificate file name.";
		ofn.Flags = OFN_PATHMUSTEXIST | OFN_FILEMUSTEXIST;

		BOOL rez;
		if ( rez=GetOpenFileNameA(&ofn) )
			::SetWindowText(GetDlgItem(IDC_EDIT_FILE), m_szFileName);

		return 0;
	}
};



