// Copyright (C) 2006 Pushok Software http://www.pushok.com/soft_svncom.php
//
// LICENSE
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License (GPL)
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// To read the license please visit http://www.gnu.org/copyleft/gpl.html
//
// Subversion is Copyrght of(c) 2000-2004 CollabNet.  All rights reserved.
// Full license available here http://subversion.tigris.org/license-1.html.

#pragma once
#include "resource.h"       // main symbols

#include "pcom.h"


// CSVNWcEntry

class ATL_NO_VTABLE CSVNWcEntry : 
	public CComObjectRootEx<CComMultiThreadModel>,
	public CComCoClass<CSVNWcEntry, &CLSID_SVNWcEntry>,
	public ISupportErrorInfo,
	public IDispatchImpl<ISVNWcEntry, &IID_ISVNWcEntry, &LIBID_PushOkSvn, /*wMajor =*/ 1, /*wMinor =*/ 0>
{
public:
	CSVNWcEntry()
	{
	}

DECLARE_REGISTRY_RESOURCEID(IDR_SVNWCENTRY)

BEGIN_COM_MAP(CSVNWcEntry)
	COM_INTERFACE_ENTRY(ISVNWcEntry)
	COM_INTERFACE_ENTRY(IDispatch)
	COM_INTERFACE_ENTRY(ISupportErrorInfo)
	COM_INTERFACE_ENTRY_AGGREGATE(IID_IMarshal, m_pUnkMarshaler.p)
END_COM_MAP()

// ISupportsErrorInfo
	STDMETHOD(InterfaceSupportsErrorInfo)(REFIID riid);

	DECLARE_PROTECT_FINAL_CONSTRUCT()
	DECLARE_GET_CONTROLLING_UNKNOWN()

	HRESULT FinalConstruct()
	{
		return CoCreateFreeThreadedMarshaler(
			GetControllingUnknown(), &m_pUnkMarshaler.p);
	}
	
	void FinalRelease() 
	{
		m_pUnkMarshaler.Release();
	}

	CComPtr<IUnknown> m_pUnkMarshaler;

private:
  CComBSTR name;
  LONG revision;
  CComBSTR url;
  CComBSTR repos;
  CComBSTR uuid;
  SvnNodeKind kind;
  SvnWcSchedule schedule;
  BOOL copied;
  BOOL deleted;
  BOOL absent;
  BOOL incomplete;
  CComBSTR copyfrom_url;
  LONG copyfrom_rev;
  CComBSTR conflict_old;
  CComBSTR conflict_new;
  CComBSTR conflict_wrk;
  CComBSTR prejfile;
  CY text_time;
  CY prop_time;
  CComBSTR checksum;
  LONG cmt_rev;
  CY cmt_date;
  CComBSTR cmt_author;
  CComBSTR lock_token;
  CComBSTR lock_owner;
  CComBSTR lock_comment;
  CY lock_creation_date;
public:
	STDMETHOD(put_Name)(BSTR sVal);
	STDMETHOD(get_Name)(BSTR* psVal);
	STDMETHOD(put_Revision)(LONG lVal);
	STDMETHOD(get_Revision)(LONG* plVal);
	STDMETHOD(put_Url)(BSTR sVal);
	STDMETHOD(get_Url)(BSTR* psVal);
	STDMETHOD(put_Repos)(BSTR sVal);
	STDMETHOD(get_Repos)(BSTR* psVal);
	STDMETHOD(put_Uuid)(BSTR sVal);
	STDMETHOD(get_Uuid)(BSTR* psVal);
	STDMETHOD(put_Kind)(SvnNodeKind Val);
	STDMETHOD(get_Kind)(SvnNodeKind* pVal);
	STDMETHOD(put_Schedule)(SvnWcSchedule Val);
	STDMETHOD(get_Schedule)(SvnWcSchedule* pVal);
	STDMETHOD(put_Copied)(BOOL blVal);
	STDMETHOD(get_Copied)(BOOL* pblVal);
	STDMETHOD(put_Deleted)(BOOL blVal);
	STDMETHOD(get_Deleted)(BOOL* pblVal);
	STDMETHOD(put_Absent)(BOOL blVal);
	STDMETHOD(get_Absent)(BOOL* pblVal);
	STDMETHOD(put_Incomplete)(BOOL blVal);
	STDMETHOD(get_Incomplete)(BOOL* pblVal);
	STDMETHOD(put_CopyFromUrl)(BSTR sVal);
	STDMETHOD(get_CopyFromUrl)(BSTR* psVal);
	STDMETHOD(put_CopyFromRev)(LONG lVal);
	STDMETHOD(get_CopyFromRev)(LONG* plVal);
	STDMETHOD(put_ConflictOld)(BSTR sVal);
	STDMETHOD(get_ConflictOld)(BSTR* psVal);
	STDMETHOD(put_ConflictNew)(BSTR sVal);
	STDMETHOD(get_ConflictNew)(BSTR* psVal);
	STDMETHOD(put_ConflictWrk)(BSTR sVal);
	STDMETHOD(get_ConflictWrk)(BSTR* psVal);
	STDMETHOD(put_Prejfile)(BSTR sVal);
	STDMETHOD(get_Prejfile)(BSTR* psVal);
	STDMETHOD(put_TextTime)(CY cyVal);
	STDMETHOD(get_TextTime)(CY* pcyVal);
	STDMETHOD(put_PropTime)(CY cyVal);
	STDMETHOD(get_PropTime)(CY* pcyVal);
	STDMETHOD(put_Checksum)(BSTR sVal);
	STDMETHOD(get_Checksum)(BSTR* psVal);
	STDMETHOD(put_CmtRev)(LONG lVal);
	STDMETHOD(get_CmtRev)(LONG* plVal);
	STDMETHOD(put_CmtDate)(CY cyVal);
	STDMETHOD(get_CmtDate)(CY* pcyVal);
	STDMETHOD(put_CmtAuthor)(BSTR sVal);
	STDMETHOD(get_CmtAuthor)(BSTR* psVal);
	STDMETHOD(put_LockToken)(BSTR sVal);
	STDMETHOD(get_LockToken)(BSTR* psVal);
	STDMETHOD(put_LockOwner)(BSTR sVal);
	STDMETHOD(get_LockOwner)(BSTR* psVal);
	STDMETHOD(put_LockComment)(BSTR sVal);
	STDMETHOD(get_LockComment)(BSTR* psVal);
	STDMETHOD(put_LockCreationDate)(CY cyVal);
	STDMETHOD(get_LockCreationDate)(CY* pcyVal);
};

OBJECT_ENTRY_AUTO(__uuidof(SVNWcEntry), CSVNWcEntry)
