// Copyright (C) 2006 Pushok Software http://www.pushok.com/soft_svncom.php
//
// LICENSE
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License (GPL)
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// To read the license please visit http://www.gnu.org/copyleft/gpl.html
//
// Subversion is Copyrght of(c) 2000-2004 CollabNet.  All rights reserved.
// Full license available here http://subversion.tigris.org/license-1.html.

#pragma once

#ifndef STRICT
#define STRICT
#endif

// Modify the following defines if you have to target a platform prior to the ones specified below.
// Refer to MSDN for the latest info on corresponding values for different platforms.
#ifndef WINVER				// Allow use of features specific to Windows 95 and Windows NT 4 or later.
#define WINVER 0x0400		// Change this to the appropriate value to target Windows 98 and Windows 2000 or later.
#endif

#ifndef _WIN32_WINNT		// Allow use of features specific to Windows NT 4 or later.
#define _WIN32_WINNT 0x0400	// Change this to the appropriate value to target Windows 2000 or later.
#endif						

#ifndef _WIN32_WINDOWS		// Allow use of features specific to Windows 98 or later.
#define _WIN32_WINDOWS 0x0410 // Change this to the appropriate value to target Windows Me or later.
#endif

#ifndef _WIN32_IE			// Allow use of features specific to IE 4.0 or later.
#define _WIN32_IE 0x0400	// Change this to the appropriate value to target IE 5.0 or later.
#endif

#define _ATL_APARTMENT_THREADED
#define _ATL_NO_AUTOMATIC_NAMESPACE

#define _ATL_CSTRING_EXPLICIT_CONSTRUCTORS	// some CString constructors will be explicit

// turns off ATL's hiding of some common and often safely ignored warning messages
#define _ATL_ALL_WARNINGS

#include <atlbase.h>
#include <atlcom.h>
#include <atlwin.h>
#include <atltypes.h>
#include <atlctl.h>
#include <atlhost.h>
#include <atlstr.h>
#include <atltime.h>
#include <atlsafe.h>

#include <vector>
#include <map>
#include <set>

using namespace ATL;

#include "pokAtlEx.h"
#include "Collections.h"

#include "svn_pools.h"
#include "svn_utf.h"
#include "svn_time.h"
#include "svn_sorts.h"
#include "svn_path.h"
#include "svn_io.h"

#include "pcom.h"

#define LOCK_THIS_OBJ ObjectLock Lock(this);

extern HINSTANCE hATLmodule_instance;  //  atl module handle

//  trace log information in file
//#define TRACE_LOG
#ifdef TRACE_LOG
static short shIndent(0);  //  spaces amount from left side
inline void PrintIndent(FILE* file)
{
	CString sIndent("");
	for(short i = 0; i < shIndent; i++)
		sIndent += "   ";
	fputs(sIndent, file);
}
#define INCREASE_INDENT shIndent++;
#define DECREASE_INDENT if(shIndent > 0) shIndent--;
#define TRACELOG_CHAR(x) TraceLog_char(x);
#define TRACELOG_TITLE(x) TraceLog_char(x, true);
#define TRACELOG_NEWLINE TraceLog_char("\n");
#define TRACELOG_WCHAR(x) TraceLog_wchar(x);
#define TRACELOG_NUMBER(x) TraceLog_number(x);
#define TRACELOG_BEGIN(x) TraceLog_begin(x);  //  x - function name
#define TRACELOG_END(x) TraceLog_end(x);  //  x - function name
#define TRACELOG_ISTRING_VECTOR(x) TraceLog_IStringVector(x);
#define TRACELOG_ISVN_WC_INFOVECTOR(x) TraceLog_ISVNWcInfoVector(x);
#define TRACELOG_ISVN_WC_PROPLIST_VECTOR(x) TraceLog_ISVNWcPropListVector(x);
#define TRACELOG_ISVN_WC_ANN_VECTOR(x) TraceLog_ISVNWcAnnVector(x);
#define TRACELOG_ISVN_WC_NOTIFY_VECTOR(x) TraceLog_ISVNWcNotifyVector(x);
#define TRACELOG_ISVN_WC_LOG_VECTOR(x) TraceLog_ISVNWcLogVector(x);
//  trace 'wchar_t' subitems 
#define CUSTOM_TRACE_SUBITEM_WCHAR(sDescription, value) \
	PrintIndent(file); \
	fputs(##sDescription##, file); \
	fputs(": ", file); \
	fputws(##value##!=NULL?##value##:"Empty", file); \
	fputs("\n", file); \
	##value##.Empty();
 //  trace 'long' subitems 
#define CUSTOM_TRACE_SUBITEM_LONG(sDescription) \
	PrintIndent(file); \
	fputs(##sDescription##, file); \
	fputs(": ", file); \
	ltoa(lSubItem, chSubItem, 10); \
	fputs(chSubItem, file); \
	fputs("\n", file);
//  trace '__int64' subitems 
#define CUSTOM_TRACE_SUBITEM_INT64(sDescription) \
	PrintIndent(file); \
	fputs(##sDescription##, file); \
	fputs(": ", file); \
	i64SubItem = unionSubItem.int64; \
	_i64toa(i64SubItem, chSubItem, 10); \
	fputs(chSubItem, file); \
	fputs("\n", file);
//  trace 'BOOL' subitems 
#define CUSTOM_TRACE_SUBITEM_BOOL(sDescription) \
	PrintIndent(file); \
	fputs(##sDescription##, file); \
	fputs(": ", file); \
	itoa(boolSubItem, chSubItem, 10); \
	fputs(chSubItem, file); \
	fputs("\n", file);
//  trace 'BOOL' subitems 
#define CUSTOM_TRACE_SUBITEM_ENUM(sDescription, enumName) \
	PrintIndent(file); \
	fputs(##sDescription##, file); \
	fputs(": ", file); \
	itoa(##enumName##, chSubItem, 10); \
	fputs(chSubItem, file); \
	fputs("\n", file);
//  return the log file location
inline CString GetLogFile(void)
{
	CString sLogPath; //  path to log file
	char buf[MAX_PATH]; 
	GetModuleFileName(hATLmodule_instance, buf, MAX_PATH);
	sLogPath = buf;
	sLogPath = sLogPath.Left(sLogPath.ReverseFind('\\'));
	sLogPath = sLogPath.Left(sLogPath.ReverseFind('\\') + 1) + "debuglog.txt";
	return sLogPath;
}
//  trace ansi string
inline void TraceLog_char(const char* log_text, bool boolTitle = false)
{
	FILE* file;  //  log file
	CString sMessage(CString(log_text == NULL ? "null" : log_text)); //  message content
	file = fopen(GetLogFile(), "a+");
	if(boolTitle) PrintIndent(file);
	fputs(sMessage, file);
	fclose(file);
}
//  trace unicode string
inline void TraceLog_wchar(wchar_t* log_text)
{
	FILE* file;  //  log file
	CStringW sMessage(CStringW(log_text == NULL ? L"null" : log_text));  //  message content
	file = fopen(GetLogFile(), "a+");
	fputws(sMessage, file);
	fclose(file);
}
//  trace number message (long)
inline void TraceLog_number(long log_number)
{
	char chLong[36];
	itoa(log_number, chLong, 10);
	TraceLog_char(chLong);
}
//  trace IStringVector fields
inline void TraceLog_IStringVector(IStringVector* log_value)
{
	FILE* file = fopen(GetLogFile(), "a+");
	if(log_value == NULL) fputs("null", file);
	else{
		long lCount;
		log_value->get_Count(&lCount);
		fputs("\n", file);
		INCREASE_INDENT
		for(long i = 1; i <= lCount; i++){
			CComBSTR wchItem;
			log_value->get_Item(i, &wchItem);
			PrintIndent(file);
			fputws(wchItem == NULL ? L"null" : wchItem, file);
			fputs("\n", file);
		}
		DECREASE_INDENT
	}
	fclose(file);
}
//  trace ISVNWcInfoVector fields
inline void TraceLog_ISVNWcInfoVector(ISVNWcInfoVector* log_value)
{
	FILE* file = fopen(GetLogFile(), "a+");
	if(log_value == NULL) fputs("null", file);
	else{
		long lCount;
		ISVNWcInfo* pItem;
		log_value->get_Count(&lCount);
		fputs("\n", file);
		INCREASE_INDENT
		for(long i = 1; i <= lCount; i++){
			log_value->get_Item(i, &pItem);
			if(pItem == NULL) fputs("item = null", file);
			else{
				fputs("item\n", file);
				INCREASE_INDENT
				CComBSTR wchSubItem;  //  bufer for 'wchar_t' subitems
				long lSubItem;  //  buffer for 'long' subitems
				BOOL boolSubItem;  //  buffer for 'BOOL' subitems
				SvnNodeKind enumNodeKind_SubItem; //  buffer for 'SvnNodeKind' subitems
				SvnWcSchedule enumSchedule_SubItem;  //  buffer for 'SvnWcSchedule' subitems
				char chSubItem[36];  //  buffer for 'char' subitems
				__int64 i64SubItem;  //  buffer for '__int64' subitems
				CY unionSubItem;  //  buffer for 'CY' subitems
				ISVNLock* pSubItems;  //  buffer for 'ISVNLock' subitems
			//  retrieve values
				pItem->get_Url(&wchSubItem); 
				CUSTOM_TRACE_SUBITEM_WCHAR("Url", wchSubItem)
				pItem->get_ReposRootUrl(&wchSubItem);
				CUSTOM_TRACE_SUBITEM_WCHAR("ReposRootUrl", wchSubItem)
				pItem->get_ReposUUID(&wchSubItem);
				CUSTOM_TRACE_SUBITEM_WCHAR("ReposUUID", wchSubItem)
				pItem->get_LastChangedAuthor(&wchSubItem);
				CUSTOM_TRACE_SUBITEM_WCHAR("LastChangedAuthor", wchSubItem)
				pItem->get_CopyFromUrl(&wchSubItem);
				CUSTOM_TRACE_SUBITEM_WCHAR("CopyFromUrl", wchSubItem)
				pItem->get_Checksum(&wchSubItem);
				CUSTOM_TRACE_SUBITEM_WCHAR("Checksum", wchSubItem)
				pItem->get_ConflictOld(&wchSubItem);
				CUSTOM_TRACE_SUBITEM_WCHAR("ConflictOld", wchSubItem)
				pItem->get_ConflictNew(&wchSubItem);
				CUSTOM_TRACE_SUBITEM_WCHAR("ConflictNew", wchSubItem)
				pItem->get_ConflictWrk(&wchSubItem);
				CUSTOM_TRACE_SUBITEM_WCHAR("ConflictWrk", wchSubItem)
				pItem->get_PrejFile(&wchSubItem);
				CUSTOM_TRACE_SUBITEM_WCHAR("PrejFile", wchSubItem)
				pItem->get_Revision(&lSubItem);
				CUSTOM_TRACE_SUBITEM_LONG("Revision")
				pItem->get_LastChangedRev(&lSubItem);
				CUSTOM_TRACE_SUBITEM_LONG("LastChangedRev")
				pItem->get_CopyFromRev(&lSubItem);
				CUSTOM_TRACE_SUBITEM_LONG("CopyFromRev")
				pItem->get_HasWcInfo(&boolSubItem);
				CUSTOM_TRACE_SUBITEM_BOOL("HasWcInfo")
				pItem->get_LastChangedDate(&unionSubItem);	
				CUSTOM_TRACE_SUBITEM_INT64("LastChangedDate")
				pItem->get_TextTime(&unionSubItem);	
				CUSTOM_TRACE_SUBITEM_INT64("TextTime")
				pItem->get_PropTime(&unionSubItem);	
				CUSTOM_TRACE_SUBITEM_INT64("PropTime")
				pItem->get_Kind(&enumNodeKind_SubItem);
				CUSTOM_TRACE_SUBITEM_ENUM("Kind", enumNodeKind_SubItem)
				pItem->get_Schedule(&enumSchedule_SubItem);	
				CUSTOM_TRACE_SUBITEM_ENUM("Schedule", enumSchedule_SubItem)
				pItem->get_Path(&wchSubItem);	
				CUSTOM_TRACE_SUBITEM_WCHAR("Path", wchSubItem)
				pItem->get_Lock(&pSubItems);	//  retrieve subitems 
				if(pSubItems == NULL) fputs("null", file);
				else{
					INCREASE_INDENT
					fputs("subitem", file);
					pSubItems->get_Path(&wchSubItem);
					CUSTOM_TRACE_SUBITEM_WCHAR("Path", wchSubItem);
					pSubItems->get_Token(&wchSubItem);
					CUSTOM_TRACE_SUBITEM_WCHAR("Token", wchSubItem);
					pSubItems->get_Owner(&wchSubItem);
					CUSTOM_TRACE_SUBITEM_WCHAR("Owner", wchSubItem);
					pSubItems->get_Comment(&wchSubItem);
					CUSTOM_TRACE_SUBITEM_WCHAR("Comment", wchSubItem);
					pSubItems->get_IsDavComment(&boolSubItem);
					CUSTOM_TRACE_SUBITEM_BOOL("IsDavComment");
					pSubItems->get_CreationDate(&unionSubItem);
					CUSTOM_TRACE_SUBITEM_INT64("CreationDate");
					pSubItems->get_ExpirationDate(&unionSubItem);
					CUSTOM_TRACE_SUBITEM_INT64("ExpirationDate");
					DECREASE_INDENT
				}
				DECREASE_INDENT
			}
			fputs("\n", file);
		}
		DECREASE_INDENT
	}
	fclose(file);
}
//  trace ISVNWcPropListVector fields
inline void TraceLog_ISVNWcPropListVector(ISVNWcPropListVector* log_value)
{
	FILE* file = fopen(GetLogFile(), "a+");
	if(log_value == NULL) fputs("null", file);
	else{
		long lCount;
		ISVNWcPropList* pItem;
		log_value->get_Count(&lCount);
		fputs("\n", file);
		INCREASE_INDENT
		for(long i = 1; i <= lCount; i++){
			log_value->get_Item(i, &pItem);
			if(pItem == NULL) fputs("item = null", file);
			else{
				CComBSTR wchSubItem;  //  bufer for 'wchar_t' subitems
				CComBSTR wchSubItemValue;  //  bufer for 'wchar_t' subitems which have value
				long lSubCount;  //  subitems count
				pItem->get_Path(&wchSubItem);
				pItem->get_CountProp(&lSubCount);
				fputs("item", file);
				fputs(" (path = ", file);
				fputws(wchSubItem, file);
				fputs(")", file);
				INCREASE_INDENT
				for(long j = 0; j < lSubCount; j++){
					if(j == 0) pItem->GetPropFirst(&wchSubItem, &wchSubItemValue);
					else pItem->GetPropNext(&wchSubItem, &wchSubItemValue);
					CUSTOM_TRACE_SUBITEM_WCHAR("SubItemName", wchSubItem);
					CUSTOM_TRACE_SUBITEM_WCHAR("SubItemValue", wchSubItemValue);
				}
				DECREASE_INDENT
			}
		fputs("\n", file);
		}
		DECREASE_INDENT
	}
	fclose(file);
}
//  trace ISVNWcAnnVector fields
inline void TraceLog_ISVNWcAnnVector(ISVNWcAnnVector* log_value)
{
	FILE* file = fopen(GetLogFile(), "a+");
	if(log_value == NULL) fputs("null", file);
	else{
		long lCount;
		ISVNWcAnn* pItem;
		log_value->get_Count(&lCount);
		fputs("\n", file);
		INCREASE_INDENT
		for(long i = 1; i <= lCount; i++){
			log_value->get_Item(i, &pItem);
			if(pItem == NULL) fputs("item = null", file);
			else{
				long lSubItem;  //  buffer for 'long' subitems
				CComBSTR wchSubItem;  //  bufer for 'wchar_t' subitems
				CY unionSubItem;  //  buffer for 'CY' subitems
				__int64 i64SubItem;  //  buffer for '__int64' subitems
				char chSubItem[36];  //  buffer for 'char' subitems
				fputs("item", file);
				INCREASE_INDENT
			//  retrieving subitems
				pItem->get_Rev(&lSubItem);
				CUSTOM_TRACE_SUBITEM_LONG("Rev")
				pItem->get_Author(&wchSubItem);
				CUSTOM_TRACE_SUBITEM_WCHAR("Author", wchSubItem)
				pItem->get_Date(&wchSubItem);
				CUSTOM_TRACE_SUBITEM_WCHAR("Date", wchSubItem)
				pItem->get_Line(&wchSubItem);
				CUSTOM_TRACE_SUBITEM_WCHAR("Line", wchSubItem)
				pItem->get_LineNo(&unionSubItem);	
				CUSTOM_TRACE_SUBITEM_INT64("LineNo")
				DECREASE_INDENT
			}
		fputs("\n", file);
		}
		DECREASE_INDENT
	}
	fclose(file);
}
//  trace ISVNWcNotifyVector fields
inline void TraceLog_ISVNWcNotifyVector(ISVNWcNotifyVector* log_value)
{
	FILE* file = fopen(GetLogFile(), "a+");
	if(log_value == NULL) fputs("null", file);
	else{
		long lCount;
		ISVNWcNotify* pItem;
		log_value->get_Count(&lCount);
		fputs("\n", file);
		INCREASE_INDENT
		for(long i = 1; i <= lCount; i++){
			log_value->get_Item(i, &pItem);
			if(pItem == NULL) fputs("item = null", file);
			else{
				long lSubItem;  //  buffer for 'long' subitems
				CComBSTR wchSubItem;  //  bufer for 'wchar_t' subitems
				char chSubItem[36];  //  buffer for 'char' subitems
				SvnWcNotifyAction enumNotifyAction_SubItem;  //  buffer for 'SvnWcNotifyAction' subitems
				SvnNodeKind enumNodeKind_SubItem;  //  buffer for 'SvnNodeKind' subitems
				SvnWcNotifyState enumNotifyState_SubItem;   //  buffer for 'SvnWcNotifyState' subitems
				SvnWcNotifyLockState enumNotifyLockState_SubItem;   //  buffer for 'SvnWcNotifyLockState' subitems
				ISVNLock* pSubItems;  //  buffer for 'ISVNLock' subitems
				BOOL boolSubItem;  //  buffer for 'BOOL' subitems
				CY unionSubItem;  //  buffer for 'CY' subitems
				__int64 i64SubItem;  //  buffer for '__int64' subitems
				fputs("item", file);
				INCREASE_INDENT
			//  retrieving subitems
				pItem->get_Path(&wchSubItem);
				CUSTOM_TRACE_SUBITEM_WCHAR("Path", wchSubItem)
				pItem->get_StrError(&wchSubItem);
				CUSTOM_TRACE_SUBITEM_WCHAR("StrError", wchSubItem)
				pItem->get_CodeError(&lSubItem);
				CUSTOM_TRACE_SUBITEM_LONG("CodeError")
				pItem->get_Revision(&lSubItem);
				CUSTOM_TRACE_SUBITEM_LONG("Revision")
				pItem->get_Action(&enumNotifyAction_SubItem);
				CUSTOM_TRACE_SUBITEM_ENUM("Action", enumNotifyAction_SubItem)
				pItem->get_Kind(&enumNodeKind_SubItem);
				CUSTOM_TRACE_SUBITEM_ENUM("Kind", enumNodeKind_SubItem)
				pItem->get_ContState(&enumNotifyState_SubItem);
				CUSTOM_TRACE_SUBITEM_ENUM("ContState", enumNotifyState_SubItem)
				pItem->get_PropState(&enumNotifyState_SubItem);
				CUSTOM_TRACE_SUBITEM_ENUM("PropState", enumNotifyState_SubItem)
				pItem->get_LockState(&enumNotifyLockState_SubItem);
				CUSTOM_TRACE_SUBITEM_ENUM("LockState", enumNotifyLockState_SubItem)
				pItem->get_Lock(&pSubItems);	//  retrieve subitems 
				if(pSubItems == NULL) fputs("null", file);
				else{
					INCREASE_INDENT
					fputs("subitem", file);
					pSubItems->get_Path(&wchSubItem);
					CUSTOM_TRACE_SUBITEM_WCHAR("Path", wchSubItem);
					pSubItems->get_Token(&wchSubItem);
					CUSTOM_TRACE_SUBITEM_WCHAR("Token", wchSubItem);
					pSubItems->get_Owner(&wchSubItem);
					CUSTOM_TRACE_SUBITEM_WCHAR("Owner", wchSubItem);
					pSubItems->get_Comment(&wchSubItem);
					CUSTOM_TRACE_SUBITEM_WCHAR("Comment", wchSubItem);
					pSubItems->get_IsDavComment(&boolSubItem);
					CUSTOM_TRACE_SUBITEM_BOOL("IsDavComment");
					pSubItems->get_CreationDate(&unionSubItem);
					CUSTOM_TRACE_SUBITEM_INT64("CreationDate");
					pSubItems->get_ExpirationDate(&unionSubItem);
					CUSTOM_TRACE_SUBITEM_INT64("ExpirationDate");
					DECREASE_INDENT
				}
				DECREASE_INDENT
			}
		fputs("\n", file);
		}
		DECREASE_INDENT
	}
	fclose(file);
}
//  trace ISVNWcLogVector fields
inline void TraceLog_ISVNWcLogVector(ISVNWcLogVector* log_value)
{
	FILE* file = fopen(GetLogFile(), "a+");
	if(log_value == NULL) fputs("null", file);
	else{
		long lCount;
		ISVNWcLog* pItem;
		log_value->get_Count(&lCount);
		fputs("\n", file);
		INCREASE_INDENT
		for(long i = 1; i <= lCount; i++){
			log_value->get_Item(i, &pItem);
			if(pItem == NULL) fputs("item = null", file);
			else{
				long lSubItem;  //  buffer for 'long' subitems
				CComBSTR wchSubItem;  //  bufer for 'wchar_t' subitems
				char chSubItem[36];  //  buffer for 'char' subitems
				fputs("item", file);
				INCREASE_INDENT
			//  retrieving subitems
				pItem->get_Author(&wchSubItem);
				CUSTOM_TRACE_SUBITEM_WCHAR("Author", wchSubItem)
				pItem->get_Date(&wchSubItem);
				CUSTOM_TRACE_SUBITEM_WCHAR("Date", wchSubItem)
				pItem->get_Message(&wchSubItem);
				CUSTOM_TRACE_SUBITEM_WCHAR("Message", wchSubItem)
				pItem->get_Revision(&lSubItem);
				CUSTOM_TRACE_SUBITEM_LONG("Revision")
				pItem->get_CountChangedPaths(&lSubItem);
				CUSTOM_TRACE_SUBITEM_LONG("CountChangedPaths")
				DECREASE_INDENT
			}
		fputs("\n", file);
		}
		DECREASE_INDENT
	}
	fclose(file);
}
inline void SendControlMsg(CString sFunction, CString sState)
{
	CTime tTime;
	tTime = tTime.GetCurrentTime();
	CString sMessage = "------- call \"" + CString(sFunction) + tTime.Format("\" (date: %d %B %Y  %H:%M:%S)");
	sMessage += " ------- " + sState + "\n";
	TraceLog_char("\n");
	TraceLog_char(sMessage.GetBuffer(), true);
}
//  begin trace message (x as function name)
inline void TraceLog_begin(char* log_begin)
{
	SendControlMsg(log_begin, "begin");
	INCREASE_INDENT
}
//  end trace message (x as function name)
inline void TraceLog_end(char* log_end)
{
	DECREASE_INDENT
	SendControlMsg(log_end, "end");
}
#else
#define TRACELOG_CHAR(x) 
#define TRACELOG_NEWLINE
#define TRACELOG_WCHAR(x)
#define TRACELOG_NUMBER(x)
#define TRACELOG_BEGIN(x)
#define TRACELOG_ISTRING_VECTOR(x)
#define TRACELOG_ISVN_WC_INFOVECTOR(x)
#define TRACELOG_ISVN_WC_PROPLIST_VECTOR(x)
#define TRACELOG_ISVN_WC_ANN_VECTOR(x)
#define TRACELOG_ISVN_WC_NOTIFY_VECTOR(x)
#define TRACELOG_ISVN_WC_LOG_VECTOR(x)
#define INCREASE_INDENT
#define DECREASE_INDENT
#define TRACELOG_TITLE(x)
#define TRACELOG_END(x)
#endif
